; Make68K - V0.10 - Copyright 1998, Mike Coates (mcoates@mame.freeserve.co.uk)
;                               & Darren Olafson (deo@mail.island.net)

		 BITS 32

		 GLOBAL _M68KRUN
		 GLOBAL _M68KRESET
		 GLOBAL _MC68000_ICount
		 GLOBAL _regs
		 EXTERN _neogeo_exception       ; FROM NEOCD.C
		 EXTERN _neogeo_exit            ; FROM NEOCD.C
		 EXTERN _cdrom_load_files       ; FROM CDROM.C
		 EXTERN _neogeo_upload          ; FROM CDROM.C
		 EXTERN _neogeo_prio_switch     ; FROM NEOCD.C
		 EXTERN _img_display            ; FROM CDROM.C
		 EXTERN _cpu_readmem24
		 EXTERN _cpu_readmem24_word
		 EXTERN _cpu_readmem24_dword

		 EXTERN _cpu_writemem24
		 EXTERN _cpu_writemem24_word
		 EXTERN _cpu_writemem24_dword
		 EXTERN _cpu_setOPbase24

; Vars Mame declares / needs access to

		 EXTERN _mame_debug
		 EXTERN _OP_ROM
		 EXTERN _OP_RAM
		 EXTERN _previouspc
		 EXTERN _ophw
		 EXTERN _cur_mrhard
		 SECTION .text

_M68KRESET:
		 pushad

; Build Jump Table (not optimised!)

		 lea   edi,[OPCODETABLE]		; Jump Table
		 lea   esi,[COMPTABLE]		; RLE Compressed Table
RESET0:
		 mov   eax,[esi]
		 add   esi,byte 4
		 xor   ecx,ecx
		 mov   cx,[esi]		; Repeats
		 add   esi,byte 2
		 test  ecx,ecx
		 jz    short RESET2		; Finished!
RESET1:
		 mov   [edi],eax
		 add   edi,byte 4
		 dec   ecx
		 jnz   short RESET1
		 jmp   short RESET0
RESET2:
		 popad
		 ret

		 ALIGN 4

_M68KRUN:
		 pusha
		 mov   esi,[R_PC]
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
; Check for Interrupt waiting

		 test  [R_IRQ],byte 07fH
		 jne   short interrupt

IntCont:
		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

MainExit:
		 mov   [R_PC],esi		; Save PC
		 mov   [R_CCR],edx
		 test  byte [R_SR_H],20H
		 mov   eax,[R_A7]		; Get A7
		 jne   short ME1		; Mode ?
		 mov   [R_USP],eax		;Save in USP
		 jmp   short MC68Kexit
		 ALIGN 4

ME1:
		 mov   [R_ISP],eax

MC68Kexit:
		 popa
		 ret
		 ALIGN 4

; Interrupt check

interrupt:
		 mov   al,byte [R_IRQ]
		 mov   ah,40h		; Mask
		 mov   ecx,7h		; Int #
inttest:
		 test   al,ah
		 jne   short highint		; Highest int found

		 ror   ah,1		; move mask
		 dec   ecx
		 jne   short inttest

highint:
		 cmp   ecx,byte 07h		; Always do a 7
		 je    short TAKEINT

		 mov   ebx,[R_SR_H]		; int mask
		 and   ebx,byte 07H
		 cmp   ecx,ebx
		 jbe   near IntCont		; Ignore at the moment

TAKEINT:
		 push  ecx		; save level

		 xor   al,ah		; clear bit
		 and   al,7Fh		; remove STOP flag
		 mov   byte [R_IRQ],al

		 mov   eax,ecx
		 add   eax,byte 24		; Vector

AUTOVECTOR:

		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_0ffff_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_0ffff_Bank:
		 pop   eax		; set Int mask
		 mov   bl,byte [R_SR_H]
		 and   bl,0F8h
		 or    bl,al
		 mov   byte [R_SR_H],bl

		 jmp   IntCont

		 ALIGN 4

Exception:
		 push  edx		; Save flags
		 and   eax,0FFH		; Zero Extend IRQ Vector
		 push  eax		; Save for Later
		 mov   al,[exception_cycles+eax]		; Get Cycles
		 sub   [_MC68000_ICount],eax		; Decrement ICount
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   ECX,edx
		 and   ECX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,ECX 				; C

		 mov   ECX,edx
		 shr   ECX,10
		 and   ECX,byte 2
		 or    eax,ECX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 mov   edi,[R_A7]		; Get A7
		 test  ah,20H	; Which Mode ?
		 jne	short ExSuperMode		; Supervisor
		 or    byte [R_SR_H],20H	; Set Supervisor Mode
		 mov   [R_USP],edi		; Save in USP
		 mov   edi,[R_ISP]		; Get ISP
ExSuperMode:
		 sub   edi,byte 6
		 mov   [R_A7],edi		; Put in A7
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 add   edi,byte 2
		 mov   [R_PC],ESI
		 push  ESI
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   eax		;Level
		 shl   eax,2
		 mov   [R_PC],ESI
		 push  EAX
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 mov   esi,eax		;Set PC
		 pop   edx		; Restore flags
		 ret
		 ALIGN 4

OP_1000:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1008:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1010:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1018:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_101f:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1020:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1027:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1028:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1030:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1030_1
		 cwde
OP_1030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1038:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1039:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_103a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_103b:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_103b_1
		 cwde
OP_103b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_103c:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1080:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1088:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1090:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1098:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_109f:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10a7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_10b0_1
		 cwde
OP_10b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10ba:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10bb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_10bb_1
		 cwde
OP_10bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10bc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10c8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_10f0_1
		 cwde
OP_10f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10fa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10fb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_10fb_1
		 cwde
OP_10fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_10fc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1100:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1108:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_111f:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1127:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1130_1
		 cwde
OP_1130_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1138:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1139:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_113a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_113b:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_113b_1
		 cwde
OP_113b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_113c:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1140:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1148:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_115f:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1167:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1170_1
		 cwde
OP_1170_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1178:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1179:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_117a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_117b:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_117b_1
		 cwde
OP_117b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_117c:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1180:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1180_1
		 cwde
OP_1180_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1188:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1188_1
		 cwde
OP_1188_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1190_1
		 cwde
OP_1190_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1198_1
		 cwde
OP_1198_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_119f:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_119f_1
		 cwde
OP_119f_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11a0_1
		 cwde
OP_11a0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11a7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11a7_1
		 cwde
OP_11a7_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11a8_1
		 cwde
OP_11a8_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11b0_1
		 cwde
OP_11b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11b0_2
		 cwde
OP_11b0_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11b8_1
		 cwde
OP_11b8_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11b9_1
		 cwde
OP_11b9_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11ba:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11ba_1
		 cwde
OP_11ba_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11bb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11bb_1
		 cwde
OP_11bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11bb_2
		 cwde
OP_11bb_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11bc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AL,AL
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11bc_1
		 cwde
OP_11bc_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11c0:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11c8:
		 and   ecx,byte 7
		 mov   EAX,[R_A0+ECX*4]
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11f0_1
		 cwde
OP_11f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11fa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11fb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_11fb_1
		 cwde
OP_11fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_11fc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AL,AL
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13c0:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13c8:
		 and   ecx,byte 7
		 mov   EAX,[R_A0+ECX*4]
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_13f0_1
		 cwde
OP_13f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13fa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13fb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_13fb_1
		 cwde
OP_13fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_13fc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AL,AL
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1ec0:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1ec8:
		 and   ecx,byte 7
		 mov   EAX,[R_A0+ECX*4]
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1ed0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1ed8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1edf:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1ee0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1ee7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1ee8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1ef0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1ef0_1
		 cwde
OP_1ef0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1ef8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1ef9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1efa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1efb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1efb_1
		 cwde
OP_1efb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1efc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f00:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f08:
		 and   ecx,byte 7
		 mov   EAX,[R_A0+ECX*4]
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f10:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f18:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f1f:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f20:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f27:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f28:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f30:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1f30_1
		 cwde
OP_1f30_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f38:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f39:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f3a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f3b:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_1f3b_1
		 cwde
OP_1f3b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_1f3c:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AL,AL
		 pushfd
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2000:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2008:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2010:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2018:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2020:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2028:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2030:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_2030_1
		 cwde
OP_2030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2038:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2039:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_203a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_203b:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_203b_1
		 cwde
OP_203b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_203c:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2040:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2048:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2050:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2058:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2060:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2068:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2070:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_2070_1
		 cwde
OP_2070_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2078:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2079:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_207a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_207b:
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_207b_1
		 cwde
OP_207b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_207c:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2080:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2088:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2090:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2098:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_20b0_1
		 cwde
OP_20b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20ba:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20bb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_20bb_1
		 cwde
OP_20bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20bc:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20c8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_20f0_1
		 cwde
OP_20f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20fa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20fb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_20fb_1
		 cwde
OP_20fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_20fc:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2100:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2108:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_2130_1
		 cwde
OP_2130_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2138:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2139:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_213a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_213b:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_213b_1
		 cwde
OP_213b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_213c:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2140:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2148:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_2170_1
		 cwde
OP_2170_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2178:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2179:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_217a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_217b:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_217b_1
		 cwde
OP_217b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_217c:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2180:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_2180_1
		 cwde
OP_2180_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2188:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_2188_1
		 cwde
OP_2188_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_2190_1
		 cwde
OP_2190_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_2198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_2198_1
		 cwde
OP_2198_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21a0_1
		 cwde
OP_21a0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21a8_1
		 cwde
OP_21a8_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21b0_1
		 cwde
OP_21b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21b0_2
		 cwde
OP_21b0_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21b8_1
		 cwde
OP_21b8_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21b9_1
		 cwde
OP_21b9_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 34
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21ba:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21ba_1
		 cwde
OP_21ba_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21bb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21bb_1
		 cwde
OP_21bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21bb_2
		 cwde
OP_21bb_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21bc:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 test  EAX,EAX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21bc_1
		 cwde
OP_21bc_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21c0:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21c8:
		 and   ecx,byte 7
		 mov   EAX,[R_A0+ECX*4]
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21f0_1
		 cwde
OP_21f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21fa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21fb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_21fb_1
		 cwde
OP_21fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_21fc:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23c0:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23c8:
		 and   ecx,byte 7
		 mov   EAX,[R_A0+ECX*4]
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_23f0_1
		 cwde
OP_23f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 34
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 36
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23fa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23fb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_23fb_1
		 cwde
OP_23fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 34
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_23fc:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 test  EAX,EAX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3000:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3008:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3010:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3018:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3020:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3028:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3030:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_3030_1
		 cwde
OP_3030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3038:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3039:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_303a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_303b:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_303b_1
		 cwde
OP_303b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_303c:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3040:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3048:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3050:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3058:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3060:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3068:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3070:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_3070_1
		 cwde
OP_3070_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3078:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3079:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_307a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_307b:
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_307b_1
		 cwde
OP_307b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 push  EDX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 mov   ecx,ebx
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_307c:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 shr   ecx,9
		 and   ecx,byte 7
		 cwde
		 mov   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3080:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3088:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3090:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3098:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_30b0_1
		 cwde
OP_30b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30ba:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30bb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_30bb_1
		 cwde
OP_30bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30bc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30c8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_30f0_1
		 cwde
OP_30f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30fa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30fb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_30fb_1
		 cwde
OP_30fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_30fc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3100:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3108:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_3130_1
		 cwde
OP_3130_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3138:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3139:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_313a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_313b:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_313b_1
		 cwde
OP_313b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_313c:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3140:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3148:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_3170_1
		 cwde
OP_3170_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3178:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3179:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_317a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_317b:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_317b_1
		 cwde
OP_317b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_317c:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3180:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_3180_1
		 cwde
OP_3180_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3188:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_3188_1
		 cwde
OP_3188_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_3190_1
		 cwde
OP_3190_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_3198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_3198_1
		 cwde
OP_3198_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31a0_1
		 cwde
OP_31a0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31a8_1
		 cwde
OP_31a8_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31b0_1
		 cwde
OP_31b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31b0_2
		 cwde
OP_31b0_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31b8_1
		 cwde
OP_31b8_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31b9_1
		 cwde
OP_31b9_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31ba:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31ba_1
		 cwde
OP_31ba_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31bb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31bb_1
		 cwde
OP_31bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31bb_2
		 cwde
OP_31bb_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31bc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AX,AX
		 pushfd
		 shr   ecx,9
		 and   ecx,byte 7
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31bc_1
		 cwde
OP_31bc_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31c0:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31c8:
		 and   ecx,byte 7
		 mov   EAX,[R_A0+ECX*4]
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31f0_1
		 cwde
OP_31f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31fa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31fb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_31fb_1
		 cwde
OP_31fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_31fc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AX,AX
		 pushfd
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33c0:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33c8:
		 and   ecx,byte 7
		 mov   EAX,[R_A0+ECX*4]
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_33f0_1
		 cwde
OP_33f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33fa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33fb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_33fb_1
		 cwde
OP_33fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_33fc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  AX,AX
		 pushfd
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0000:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 or    AL,BL
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0010:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0018:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_001f:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0020:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0027:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0028:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0030:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0030_1
		 cwde
OP_0030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0038:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0039:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_003c:
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   ECX,edx
		 and   ECX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,ECX 				; C

		 mov   ECX,edx
		 shr   ECX,10
		 and   ECX,byte 2
		 or    eax,ECX				; O

		 and   eax,byte 1Fh
		 or    AL,BL
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0040:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 or    AX,BX
		 pushfd
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0050:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0058:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0060:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0068:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0070:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0070_1
		 cwde
OP_0070_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0078:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0079:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_007c:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 jne   near OP_007c_1

		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_0007c_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_0007c_Bank:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_007c_1:
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   ECX,edx
		 and   ECX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,ECX 				; C

		 mov   ECX,edx
		 shr   ECX,10
		 and   ECX,byte 2
		 or    eax,ECX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 or    AX,BX
		 test  ah,20h 			; User Mode ?
		 jne   short OP_007c_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_007c_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0080:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EAX,[R_D0+ECX*4]
		 or    EAX,EBX
		 pushfd
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0090:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0098:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_00a0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_00a8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_00b0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_00b0_1
		 cwde
OP_00b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 34
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_00b8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_00b9:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 36
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0200:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 and   AL,BL
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0210:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0218:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_021f:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0220:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0227:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0228:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0230:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0230_1
		 cwde
OP_0230_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0238:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0239:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_023c:
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   ECX,edx
		 and   ECX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,ECX 				; C

		 mov   ECX,edx
		 shr   ECX,10
		 and   ECX,byte 2
		 or    eax,ECX				; O

		 and   eax,byte 1Fh
		 and   AL,BL
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0240:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 and   AX,BX
		 pushfd
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0250:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0258:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0260:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0268:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0270:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0270_1
		 cwde
OP_0270_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0278:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0279:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_027c:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 jne   near OP_027c_1

		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_0027c_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_0027c_Bank:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_027c_1:
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   ECX,edx
		 and   ECX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,ECX 				; C

		 mov   ECX,edx
		 shr   ECX,10
		 and   ECX,byte 2
		 or    eax,ECX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 and   AX,BX
		 test  ah,20h 			; User Mode ?
		 jne   short OP_027c_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_027c_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0280:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EAX,[R_D0+ECX*4]
		 and   EAX,EBX
		 pushfd
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0290:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0298:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_02a0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_02a8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_02b0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_02b0_1
		 cwde
OP_02b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 34
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_02b8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_02b9:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 36
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0400:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 sub   AL,BL
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0410:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0418:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_041f:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0420:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0427:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0428:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0430:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0430_1
		 cwde
OP_0430_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0438:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0439:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0440:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 sub   AX,BX
		 pushfd
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0450:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0458:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0460:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0468:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0470:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0470_1
		 cwde
OP_0470_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0478:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0479:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0480:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EAX,[R_D0+ECX*4]
		 sub   EAX,EBX
		 pushfd
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0490:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0498:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_04a0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_04a8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_04b0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_04b0_1
		 cwde
OP_04b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 34
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_04b8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_04b9:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 36
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0600:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 add   AL,BL
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0610:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0618:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_061f:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0620:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0627:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0628:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0630:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0630_1
		 cwde
OP_0630_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0638:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0639:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0640:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 add   AX,BX
		 pushfd
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0650:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0658:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0660:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0668:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0670:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0670_1
		 cwde
OP_0670_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0678:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0679:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0680:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EAX,[R_D0+ECX*4]
		 add   EAX,EBX
		 pushfd
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0690:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0698:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_06a0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_06a8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_06b0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_06b0_1
		 cwde
OP_06b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 34
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_06b8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_06b9:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 36
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a00:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 xor   AL,BL
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a10:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a18:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a1f:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a20:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a27:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a28:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a30:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0a30_1
		 cwde
OP_0a30_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a38:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a39:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,BL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a3c:
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   ECX,edx
		 and   ECX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,ECX 				; C

		 mov   ECX,edx
		 shr   ECX,10
		 and   ECX,byte 2
		 or    eax,ECX				; O

		 and   eax,byte 1Fh
		 xor   AL,BL
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a40:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 xor   AX,BX
		 pushfd
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a50:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a58:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a60:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a68:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a70:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0a70_1
		 cwde
OP_0a70_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a78:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a79:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,BX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a7c:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 jne   near OP_0a7c_1

		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_00a7c_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_00a7c_Bank:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_0a7c_1:
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   ECX,edx
		 and   ECX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,ECX 				; C

		 mov   ECX,edx
		 shr   ECX,10
		 and   ECX,byte 2
		 or    eax,ECX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 xor   AX,BX
		 test  ah,20h 			; User Mode ?
		 jne   short OP_0a7c_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_0a7c_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a80:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EAX,[R_D0+ECX*4]
		 xor   EAX,EBX
		 pushfd
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a90:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0a98:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0aa0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0aa8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0ab0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0ab0_1
		 cwde
OP_0ab0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 34
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0ab8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 32
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0ab9:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,EBX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 36
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c00:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c10:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c18:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c1f:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c20:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c27:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c28:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c30:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0c30_1
		 cwde
OP_0c30_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c38:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c39:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c3c:
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   ECX,edx
		 and   ECX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,ECX 				; C

		 mov   ECX,edx
		 shr   ECX,10
		 and   ECX,byte 2
		 or    eax,ECX				; O

		 and   eax,byte 1Fh
		 cmp   AL,BL
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c40:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EAX,[R_D0+ECX*4]
		 cmp   AX,BX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c50:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   AX,BX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c58:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   AX,BX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c60:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   AX,BX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c68:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   AX,BX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c70:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0c70_1
		 cwde
OP_0c70_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   AX,BX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c78:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   AX,BX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c79:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   AX,BX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c7c:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 jne   near OP_0c7c_1

		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_00c7c_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_00c7c_Bank:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_0c7c_1:
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   ECX,edx
		 and   ECX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,ECX 				; C

		 mov   ECX,edx
		 shr   ECX,10
		 and   ECX,byte 2
		 or    eax,ECX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 cmp   AX,BX
		 test  ah,20h 			; User Mode ?
		 jne   short OP_0c7c_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_0c7c_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c80:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EAX,[R_D0+ECX*4]
		 cmp   EAX,EBX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c90:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   EAX,EBX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0c98:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   EAX,EBX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0ca0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   EAX,EBX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0ca8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   EAX,EBX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0cb0:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0cb0_1
		 cwde
OP_0cb0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   EAX,EBX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0cb8:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   EAX,EBX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0cb9:
		 and   ecx,byte 7
		 mov   EBX,dword [esi+ebp]
		 rol   EBX,16
		 add   esi,byte 4
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   EAX,EBX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0100:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 31
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 and   dl,0BFH	;Clear Zero Flag
		 test  [R_D0+ebx*4],ECX
		 jnz   short OP_0100_1
		 or    dl,40h
OP_0100_1:
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0110_1
		 or    dl,40h
OP_0110_1:
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0118_1
		 or    dl,40h
OP_0118_1:
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0120_1
		 or    dl,40h
OP_0120_1:
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0128_1
		 or    dl,40h
OP_0128_1:
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0130_1
		 cwde
OP_0130_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0130_2
		 or    dl,40h
OP_0130_2:
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0138:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0138_1
		 or    dl,40h
OP_0138_1:
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0139:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0139_1
		 or    dl,40h
OP_0139_1:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_013a:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_013a_1
		 or    dl,40h
OP_013a_1:
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_013b:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_013b_1
		 cwde
OP_013b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_013b_2
		 or    dl,40h
OP_013b_2:
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0140:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 31
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 and   dl,0BFH	;Clear Zero Flag
		 test  [R_D0+ebx*4],ECX
		 jnz   short OP_0140_1
		 or    dl,40h
OP_0140_1:
		 xor   [R_D0+ebx*4],ECX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0150_1
		 or    dl,40h
OP_0150_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0158_1
		 or    dl,40h
OP_0158_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0160_1
		 or    dl,40h
OP_0160_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0168_1
		 or    dl,40h
OP_0168_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0170_1
		 cwde
OP_0170_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0170_2
		 or    dl,40h
OP_0170_2:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0178:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0178_1
		 or    dl,40h
OP_0178_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0179:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0179_1
		 or    dl,40h
OP_0179_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0180:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 31
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 and   dl,0BFH	;Clear Zero Flag
		 test  [R_D0+ebx*4],ECX
		 jnz   short OP_0180_1
		 or    dl,40h
OP_0180_1:
		 not   ecx
		 and   [R_D0+ebx*4],ECX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0190_1
		 or    dl,40h
OP_0190_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0198_1
		 or    dl,40h
OP_0198_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01a0_1
		 or    dl,40h
OP_01a0_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01a8_1
		 or    dl,40h
OP_01a8_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_01b0_1
		 cwde
OP_01b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01b0_2
		 or    dl,40h
OP_01b0_2:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01b8:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01b8_1
		 or    dl,40h
OP_01b8_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01b9:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01b9_1
		 or    dl,40h
OP_01b9_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 31
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 and   dl,0BFH	;Clear Zero Flag
		 test  [R_D0+ebx*4],ECX
		 jnz   short OP_01c0_1
		 or    dl,40h
OP_01c0_1:
		 or    [R_D0+ebx*4],ECX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01d0_1
		 or    dl,40h
OP_01d0_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01d8_1
		 or    dl,40h
OP_01d8_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01e0_1
		 or    dl,40h
OP_01e0_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01e8_1
		 or    dl,40h
OP_01e8_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_01f0_1
		 cwde
OP_01f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01f0_2
		 or    dl,40h
OP_01f0_2:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01f8:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01f8_1
		 or    dl,40h
OP_01f8_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01f9:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   ecx, [R_D0+ECX*4]
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_01f9_1
		 or    dl,40h
OP_01f9_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0108:
		 push  edx
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 mov   bh,al
		 add   edi,byte 2
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 mov   bl,al
		 mov   [R_D0+ecx*4],bx
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0148:
		 push  edx
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 mov   bh,al
		 add   edi,byte 2
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 mov   bl,al
		 add   edi,byte 2
		 shl   ebx,16
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 mov   bh,al
		 add   edi,byte 2
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 mov   bl,al
		 mov   [R_D0+ecx*4],ebx
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0188:
		 push  edx
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   eax,[R_D0+ecx*4]
		 rol   eax,24
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 pop   EAX
		 pop   EAX
		 add   edi,byte 2
		 rol   eax,byte 8
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 pop   EAX
		 pop   EAX
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_01c8:
		 push  edx
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   eax,[R_D0+ecx*4]
		 rol   eax,8
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 pop   EAX
		 pop   EAX
		 add   edi,byte 2
		 rol   eax,byte 8
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 pop   EAX
		 pop   EAX
		 add   edi,byte 2
		 rol   eax,byte 8
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 pop   EAX
		 pop   EAX
		 add   edi,byte 2
		 rol   eax,byte 8
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 pop   EAX
		 pop   EAX
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0800:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 31
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 and   dl,0BFH	;Clear Zero Flag
		 test  [R_D0+ebx*4],ECX
		 jnz   short OP_0800_1
		 or    dl,40h
OP_0800_1:
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0810:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0810_1
		 or    dl,40h
OP_0810_1:
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0818:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0818_1
		 or    dl,40h
OP_0818_1:
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0820:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0820_1
		 or    dl,40h
OP_0820_1:
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0828:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0828_1
		 or    dl,40h
OP_0828_1:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0830:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0830_1
		 cwde
OP_0830_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0830_2
		 or    dl,40h
OP_0830_2:
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0838:
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0838_1
		 or    dl,40h
OP_0838_1:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0839:
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0839_1
		 or    dl,40h
OP_0839_1:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_083a:
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_083a_1
		 or    dl,40h
OP_083a_1:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_083b:
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_083b_1
		 cwde
OP_083b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_083b_2
		 or    dl,40h
OP_083b_2:
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0840:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 31
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 and   dl,0BFH	;Clear Zero Flag
		 test  [R_D0+ebx*4],ECX
		 jnz   short OP_0840_1
		 or    dl,40h
OP_0840_1:
		 xor   [R_D0+ebx*4],ECX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0850:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0850_1
		 or    dl,40h
OP_0850_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0858:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0858_1
		 or    dl,40h
OP_0858_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0860:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0860_1
		 or    dl,40h
OP_0860_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0868:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0868_1
		 or    dl,40h
OP_0868_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0870:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_0870_1
		 cwde
OP_0870_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0870_2
		 or    dl,40h
OP_0870_2:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0878:
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0878_1
		 or    dl,40h
OP_0878_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0879:
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0879_1
		 or    dl,40h
OP_0879_1:
		 xor   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0880:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 31
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 and   dl,0BFH	;Clear Zero Flag
		 test  [R_D0+ebx*4],ECX
		 jnz   short OP_0880_1
		 or    dl,40h
OP_0880_1:
		 not   ecx
		 and   [R_D0+ebx*4],ECX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0890:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0890_1
		 or    dl,40h
OP_0890_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_0898:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_0898_1
		 or    dl,40h
OP_0898_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08a0:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08a0_1
		 or    dl,40h
OP_08a0_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08a8:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08a8_1
		 or    dl,40h
OP_08a8_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08b0:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_08b0_1
		 cwde
OP_08b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08b0_2
		 or    dl,40h
OP_08b0_2:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08b8:
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08b8_1
		 or    dl,40h
OP_08b8_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08b9:
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08b9_1
		 or    dl,40h
OP_08b9_1:
		 not   ecx
		 and   AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08c0:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 31
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 and   dl,0BFH	;Clear Zero Flag
		 test  [R_D0+ebx*4],ECX
		 jnz   short OP_08c0_1
		 or    dl,40h
OP_08c0_1:
		 or    [R_D0+ebx*4],ECX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08d0:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08d0_1
		 or    dl,40h
OP_08d0_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08d8:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08d8_1
		 or    dl,40h
OP_08d8_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08e0:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08e0_1
		 or    dl,40h
OP_08e0_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08e8:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08e8_1
		 or    dl,40h
OP_08e8_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08f0:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_08f0_1
		 cwde
OP_08f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08f0_2
		 or    dl,40h
OP_08f0_2:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08f8:
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08f8_1
		 or    dl,40h
OP_08f8_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_08f9:
		 mov   ECX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx, byte 7
		 mov   eax,1
		 shl   eax,cl
		 mov   ecx,eax
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 and   dl,0BFH	;Clear Zero Flag
		 test  AL,CL
		 jnz   short OP_08f9_1
		 or    dl,40h
OP_08f9_1:
		 or    AL,CL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_A0+ECX*4],edi
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_A0+ECX*4],edi
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_41f0_1
		 cwde
OP_41f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_A0+ECX*4],edi
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41f8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_A0+ECX*4],edi
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41f9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_A0+ECX*4],edi
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41fa:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_A0+ECX*4],edi
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41fb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_41fb_1
		 cwde
OP_41fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_A0+ECX*4],edi
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4850:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 and   ECX,0FFFFFFh
		 push  EDX
		 push  EDI
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4868:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 and   ECX,0FFFFFFh
		 push  EDX
		 push  EDI
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4870:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4870_1
		 cwde
OP_4870_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 and   ECX,0FFFFFFh
		 push  EDX
		 push  EDI
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4878:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 and   ECX,0FFFFFFh
		 push  EDX
		 push  EDI
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4879:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 and   ECX,0FFFFFFh
		 push  EDX
		 push  EDI
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_487a:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 and   ECX,0FFFFFFh
		 push  EDX
		 push  EDI
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_487b:
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_487b_1
		 cwde
OP_487b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 and   ECX,0FFFFFFh
		 push  EDX
		 push  EDI
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40c0:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 mov   [R_D0+ECX*4],AX
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40d0:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40d8:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40e0:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40e8:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40f0:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_40f0_1
		 cwde
OP_40f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40f8:
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40f9:
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 mov   ah,byte [R_SR_H] 	; T, S & I

		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42c0:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 and   eax,byte 1Fh
		 mov   [R_D0+ECX*4],AX
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42d0:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 and   eax,byte 1Fh
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42d8:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 and   eax,byte 1Fh
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42e0:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 and   eax,byte 1Fh
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42e8:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 and   eax,byte 1Fh
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42f0:
		 and   ecx,byte 7
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 and   eax,byte 1Fh
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_42f0_1
		 cwde
OP_42f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42f8:
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 and   eax,byte 1Fh
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42f9:
		 mov   eax,edx
		 mov   ah,byte [R_XC]
		 mov   EBX,edx
		 and   EBX,byte 1
		 shr   eax,4
		 and   eax,byte 01Ch 		; X, N & Z

		 or    eax,EBX 				; C

		 mov   EBX,edx
		 shr   EBX,10
		 and   EBX,byte 2
		 or    eax,EBX				; O

		 and   eax,byte 1Fh
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44c0:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_44f0_1
		 cwde
OP_44f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44fa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44fb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_44fb_1
		 cwde
OP_44fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44fc:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46c0:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46c0_1

		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46c0_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46c0_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46c0_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046c0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046c0_Bank:
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46d0:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46d0_1

		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46d0_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46d0_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46d0_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046d0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046d0_Bank:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46d8:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46d8_1

		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46d8_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46d8_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46d8_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046d8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046d8_Bank:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46e0:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46e0_1

		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46e0_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46e0_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46e0_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046e0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046e0_Bank:
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46e8:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46e8_1

		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46e8_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46e8_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46e8_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046e8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046e8_Bank:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46f0:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46f0_1

		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_46f0_2
		 cwde
OP_46f0_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46f0_3

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46f0_3:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46f0_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046f0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046f0_Bank:
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46f8:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46f8_1

		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46f8_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46f8_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46f8_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046f8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046f8_Bank:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46f9:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46f9_1

		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46f9_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46f9_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46f9_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046f9_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046f9_Bank:
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46fa:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46fa_1

		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46fa_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46fa_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46fa_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046fa_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046fa_Bank:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46fb:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46fb_1

		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_46fb_2
		 cwde
OP_46fb_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46fb_3

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46fb_3:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46fb_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046fb_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046fb_Bank:
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46fc:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_46fc_1

		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  ah,20h 			; User Mode ?
		 jne   short OP_46fc_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_46fc_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_46fc_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_046fc_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_046fc_Bank:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5000:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   [R_D0+ebx*4],CL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5088:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   [R_A0+ebx*4],ECX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5010:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5018:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_501f:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5020:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5027:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5028:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5030:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_5030_1
		 cwde
OP_5030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5038:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5039:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5040:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   [R_D0+ebx*4],CX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5050:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5058:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5060:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5068:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5070:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_5070_1
		 cwde
OP_5070_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5078:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5079:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5080:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   [R_D0+ebx*4],ECX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5090:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5098:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_50b0_1
		 cwde
OP_50b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 add   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50c0:
		 and   ecx,byte 7
		 mov   AL,byte 0ffh
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50c8:
		 jmp   short OP_50c8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_50c8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_50c8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 mov   AL,byte 0ffh
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 mov   AL,byte 0ffh
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 mov   AL,byte 0ffh
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 mov   AL,byte 0ffh
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 mov   AL,byte 0ffh
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 mov   AL,byte 0ffh
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_50f0_1
		 cwde
OP_50f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 mov   AL,byte 0ffh
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 mov   AL,byte 0ffh
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_50f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 mov   AL,byte 0ffh
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5100:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   [R_D0+ebx*4],CL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5188:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   [R_A0+ebx*4],ECX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_511f:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5127:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_5130_1
		 cwde
OP_5130_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5138:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5139:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AL,CL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5140:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   [R_D0+ebx*4],CX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_5170_1
		 cwde
OP_5170_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5178:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5179:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   AX,CX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5180:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   [R_D0+ebx*4],ECX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_51b0_1
		 cwde
OP_51b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 shr   ecx,9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 sub   EAX,ECX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51c0:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51c8:
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_51c8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_51c8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 xor   eax,eax
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 xor   eax,eax
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 xor   eax,eax
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 xor   eax,eax
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 xor   eax,eax
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 xor   eax,eax
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_51f0_1
		 cwde
OP_51f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 xor   eax,eax
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 xor   eax,eax
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_51f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 xor   eax,eax
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52c0:
		 and   ecx,byte 7
		 mov   ah,dl
		 sahf
		 seta  AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52c8:
		 mov   ah,dl
		 sahf
		 ja    short OP_52c8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_52c8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_52c8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 seta  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 seta  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 seta  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 seta  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 seta  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 seta  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_52f0_1
		 cwde
OP_52f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 seta  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 seta  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_52f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 seta  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53c0:
		 and   ecx,byte 7
		 mov   ah,dl
		 sahf
		 setbe AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53c8:
		 mov   ah,dl
		 sahf
		 jbe   short OP_53c8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_53c8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_53c8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 setbe AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 setbe AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 setbe AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 setbe AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 setbe AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 setbe AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_53f0_1
		 cwde
OP_53f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 setbe AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 setbe AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_53f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 mov   ah,dl
		 sahf
		 setbe AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54c0:
		 and   ecx,byte 7
		 test  dl,1		;Check Carry
		 setz  AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54c8:
		 test  dl,1H		;check carry
		 jz    short OP_54c8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_54c8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_54c8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_54f0_1
		 cwde
OP_54f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_54f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55c0:
		 and   ecx,byte 7
		 test  dl,1		;Check Carry
		 setnz AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55c8:
		 test  dl,1H		;check carry
		 jnz   short OP_55c8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_55c8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_55c8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_55f0_1
		 cwde
OP_55f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_55f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 test  dl,1		;Check Carry
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56c0:
		 and   ecx,byte 7
		 test  dl,40H		;Check Zero
		 setz  AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56c8:
		 test  dl,40H		;Check zero
		 jz    short OP_56c8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_56c8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_56c8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_56f0_1
		 cwde
OP_56f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_56f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57c0:
		 and   ecx,byte 7
		 test  dl,40H		;Check Zero
		 setnz AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57c8:
		 test  dl,40H		;Check zero
		 jnz   short OP_57c8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_57c8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_57c8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_57f0_1
		 cwde
OP_57f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_57f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 test  dl,40H		;Check Zero
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58c0:
		 and   ecx,byte 7
		 test  dx,800H		;Check Overflow
		 setz  AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58c8:
		 test  dx,800H		;Check Overflow
		 jz    short OP_58c8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_58c8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_58c8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_58f0_1
		 cwde
OP_58f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_58f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59c0:
		 and   ecx,byte 7
		 test  dx,800H		;Check Overflow
		 setnz AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59c8:
		 test  dx,800H		;Check Overflow
		 jnz   short OP_59c8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_59c8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_59c8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59df:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59e7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_59f0_1
		 cwde
OP_59f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59f8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_59f9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 test  dx,800H		;Check Overflow
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ac0:
		 and   ecx,byte 7
		 test  dl,80H		;Check Sign
		 setz  AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ac8:
		 test  dl,80H		;Check Sign
		 jz    short OP_5ac8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_5ac8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_5ac8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ad0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ad8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5adf:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ae0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ae7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ae8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5af0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_5af0_1
		 cwde
OP_5af0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5af8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5af9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setz  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5bc0:
		 and   ecx,byte 7
		 test  dl,80H		;Check Sign
		 setnz AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5bc8:
		 test  dl,80H		;Check Sign
		 jnz   short OP_5bc8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_5bc8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_5bc8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5bd0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5bd8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5bdf:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5be0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5be7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5be8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5bf0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_5bf0_1
		 cwde
OP_5bf0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5bf8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5bf9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 test  dl,80H		;Check Sign
		 setnz AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5cc0:
		 and   ecx,byte 7
		 push  edx
		 popf
		 setge AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5cc8:
		 or    edx,200h
		 push  edx
		 popf
		 jge   short OP_5cc8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_5cc8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_5cc8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5cd0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setge AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5cd8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setge AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5cdf:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setge AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ce0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setge AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ce7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setge AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ce8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setge AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5cf0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_5cf0_1
		 cwde
OP_5cf0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setge AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5cf8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setge AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5cf9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setge AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5dc0:
		 and   ecx,byte 7
		 push  edx
		 popf
		 setl  AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5dc8:
		 or    edx,200h
		 push  edx
		 popf
		 jl    short OP_5dc8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_5dc8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_5dc8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5dd0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setl  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5dd8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setl  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ddf:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setl  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5de0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setl  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5de7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setl  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5de8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setl  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5df0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_5df0_1
		 cwde
OP_5df0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setl  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5df8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setl  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5df9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setl  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ec0:
		 and   ecx,byte 7
		 push  edx
		 popf
		 setg  AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ec8:
		 or    edx,200h
		 push  edx
		 popf
		 jg    short OP_5ec8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_5ec8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_5ec8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ed0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setg  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ed8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setg  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5edf:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setg  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ee0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setg  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ee7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setg  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ee8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setg  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ef0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_5ef0_1
		 cwde
OP_5ef0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setg  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ef8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setg  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ef9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setg  AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5fc0:
		 and   ecx,byte 7
		 push  edx
		 popf
		 setle AL
		 neg   byte AL
		 mov   [R_D0+ECX*4],AL
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5fc8:
		 or    edx,200h
		 push  edx
		 popf
		 jle   short OP_5fc8_1
		 and   ecx,byte 7
		 mov   ax,[R_D0+ecx*4]
		 dec   ax
		 mov   [R_D0+ecx*4],ax
		 inc   ax		; Is it -1
		 jz    short OP_5fc8_1
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_5fc8_1:
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5fd0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setle AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5fd8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setle AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5fdf:
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setle AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5fe0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setle AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5fe7:
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setle AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5fe8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setle AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ff0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_5ff0_1
		 cwde
OP_5ff0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setle AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ff8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setle AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_5ff9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 and   edi,0FFFFFFh
		 push  edx
		 popf
		 setle AL
		 neg   byte AL
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6000:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6001:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_60ff:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6100:
		 mov   edi,[R_A7]      ; Get A7
		 mov   eax,esi            ; Get PC
		 sub   edi,byte 4         ; Decrement A7
		 add   eax,byte 2         ; Skip Displacement
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6101:
		 mov   edi,[R_A7]      ; Get A7
		 sub   edi,byte 4         ; Decrement
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 pop   ECX
		 pop   ESI
		 pop   EDX
		 pop   ECX
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_61ff:
		 mov   edi,[R_A7]      ; Get A7
		 mov   eax,esi            ; Get PC
		 sub   edi,byte 4         ; Decrement A7
		 add   eax,byte 2         ; Skip Displacement
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6200:
		 mov   ah,dl
		 sahf
		 ja    short OP_6200_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6200_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6201:
		 mov   ah,dl
		 sahf
		 ja    short OP_6201_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6201_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_62ff:
		 mov   ah,dl
		 sahf
		 ja    short OP_62ff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_62ff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6300:
		 mov   ah,dl
		 sahf
		 jbe   short OP_6300_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6300_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6301:
		 mov   ah,dl
		 sahf
		 jbe   short OP_6301_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6301_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_63ff:
		 mov   ah,dl
		 sahf
		 jbe   short OP_63ff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_63ff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6400:
		 test  dl,1H		;check carry
		 jz    short OP_6400_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6400_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6401:
		 test  dl,1H		;check carry
		 jz    short OP_6401_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6401_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_64ff:
		 test  dl,1H		;check carry
		 jz    short OP_64ff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_64ff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6500:
		 test  dl,1H		;check carry
		 jnz   short OP_6500_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6500_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6501:
		 test  dl,1H		;check carry
		 jnz   short OP_6501_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6501_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_65ff:
		 test  dl,1H		;check carry
		 jnz   short OP_65ff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_65ff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6600:
		 test  dl,40H		;Check zero
		 jz    short OP_6600_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6600_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6601:
		 test  dl,40H		;Check zero
		 jz    short OP_6601_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6601_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_66ff:
		 test  dl,40H		;Check zero
		 jz    short OP_66ff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_66ff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6700:
		 test  dl,40H		;Check zero
		 jnz   short OP_6700_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6700_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6701:
		 test  dl,40H		;Check zero
		 jnz   short OP_6701_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6701_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_67ff:
		 test  dl,40H		;Check zero
		 jnz   short OP_67ff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_67ff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6800:
		 test  dx,800H		;Check Overflow
		 jz    short OP_6800_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6800_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6801:
		 test  dx,800H		;Check Overflow
		 jz    short OP_6801_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6801_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_68ff:
		 test  dx,800H		;Check Overflow
		 jz    short OP_68ff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_68ff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6900:
		 test  dx,800H		;Check Overflow
		 jnz   short OP_6900_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6900_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6901:
		 test  dx,800H		;Check Overflow
		 jnz   short OP_6901_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6901_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_69ff:
		 test  dx,800H		;Check Overflow
		 jnz   short OP_69ff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_69ff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6a00:
		 test  dl,80H		;Check Sign
		 jz    short OP_6a00_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6a00_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6a01:
		 test  dl,80H		;Check Sign
		 jz    short OP_6a01_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6a01_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6aff:
		 test  dl,80H		;Check Sign
		 jz    short OP_6aff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6aff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6b00:
		 test  dl,80H		;Check Sign
		 jnz   short OP_6b00_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6b00_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6b01:
		 test  dl,80H		;Check Sign
		 jnz   short OP_6b01_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6b01_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6bff:
		 test  dl,80H		;Check Sign
		 jnz   short OP_6bff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6bff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6c00:
		 or    edx,200h
		 push  edx
		 popf
		 jge   short OP_6c00_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6c00_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6c01:
		 or    edx,200h
		 push  edx
		 popf
		 jge   short OP_6c01_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6c01_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6cff:
		 or    edx,200h
		 push  edx
		 popf
		 jge   short OP_6cff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6cff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6d00:
		 or    edx,200h
		 push  edx
		 popf
		 jl    short OP_6d00_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6d00_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6d01:
		 or    edx,200h
		 push  edx
		 popf
		 jl    short OP_6d01_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6d01_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6dff:
		 or    edx,200h
		 push  edx
		 popf
		 jl    short OP_6dff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6dff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6e00:
		 or    edx,200h
		 push  edx
		 popf
		 jg    short OP_6e00_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6e00_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6e01:
		 or    edx,200h
		 push  edx
		 popf
		 jg    short OP_6e01_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6e01_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6eff:
		 or    edx,200h
		 push  edx
		 popf
		 jg    short OP_6eff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6eff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6f00:
		 or    edx,200h
		 push  edx
		 popf
		 jle   short OP_6f00_1
		 add   esi,byte 2
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6f00_1:
		 movsx EAX,word [esi+ebp]
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6f01:
		 or    edx,200h
		 push  edx
		 popf
		 jle   short OP_6f01_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6f01_1:
		 movsx eax,cl               ; Sign Extend displacement
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_6fff:
		 or    edx,200h
		 push  edx
		 popf
		 jle   short OP_6fff_1
		 add   esi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_6fff_1:
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,eax
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_7000:
		 movsx eax,cl
		 shr   ecx,9
		 and   ecx,byte 7
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 mov   [R_D0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8100:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EBX,[R_D0+EBX*4]
		 mov   EAX,[R_D0+ECX*4]
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8108:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  ECX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c100:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EBX,[R_D0+EBX*4]
		 mov   EAX,[R_D0+ECX*4]
		 bt    dword [R_XC],0
		 adc   al,bl
		 daa
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c108:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  ECX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 bt    dword [R_XC],0
		 adc   al,bl
		 daa
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8000:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8010:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8018:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_801f:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8020:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8027:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8028:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8030:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_8030_1
		 cwde
OP_8030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8038:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8039:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_803a:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_803b:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_803b_1
		 cwde
OP_803b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_803c:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 or    [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8040:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8050:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8058:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8060:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8068:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8070:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_8070_1
		 cwde
OP_8070_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8078:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8079:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_807a:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_807b:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_807b_1
		 cwde
OP_807b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_807c:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 or    [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8080:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8090:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8098:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_80b0_1
		 cwde
OP_80b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80b8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80b9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80ba:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80bb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_80bb_1
		 cwde
OP_80bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80bc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 or    [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_811f:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8127:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_8130_1
		 cwde
OP_8130_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8138:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8139:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 or    AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_8170_1
		 cwde
OP_8170_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8178:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8179:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 or    AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_8198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_81b0_1
		 cwde
OP_81b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81b8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81b9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 or    EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9000:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9010:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9018:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_901f:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9020:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9027:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9028:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9030:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_9030_1
		 cwde
OP_9030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9038:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9039:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_903a:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_903b:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_903b_1
		 cwde
OP_903b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_903c:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 sub   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9040:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9048:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9050:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9058:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9060:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9068:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9070:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_9070_1
		 cwde
OP_9070_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9078:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9079:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_907a:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_907b:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_907b_1
		 cwde
OP_907b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_907c:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 sub   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9080:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9088:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9090:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9098:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_90b0_1
		 cwde
OP_90b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90b8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90b9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90ba:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90bb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_90bb_1
		 cwde
OP_90bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90bc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 sub   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_911f:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9127:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_9130_1
		 cwde
OP_9130_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9138:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9139:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 sub   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_9170_1
		 cwde
OP_9170_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9178:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9179:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 sub   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_91b0_1
		 cwde
OP_91b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91b8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91b9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 sub   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90c8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_90f0_1
		 cwde
OP_90f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90f8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90f9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90fa:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90fb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_90fb_1
		 cwde
OP_90fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_90fc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 cwde
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91c8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_91f0_1
		 cwde
OP_91f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91f8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91f9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91fa:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91fb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_91fb_1
		 cwde
OP_91fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_91fc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 sub   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b000:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b008:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b010:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b018:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b01f:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b020:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b027:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b028:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b030:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b030_1
		 cwde
OP_b030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b038:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b039:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b03a:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b03b:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b03b_1
		 cwde
OP_b03b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b03c:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 cmp   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b040:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b048:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b050:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b058:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b060:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b068:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b070:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b070_1
		 cwde
OP_b070_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b078:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b079:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b07a:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b07b:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b07b_1
		 cwde
OP_b07b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b07c:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 cmp   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b080:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b088:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b090:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b098:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b0b0_1
		 cwde
OP_b0b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0b8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0b9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0ba:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0bb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b0bb_1
		 cwde
OP_b0bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0bc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 cmp   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0c8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b0f0_1
		 cwde
OP_b0f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0f8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0f9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0fa:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0fb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b0fb_1
		 cwde
OP_b0fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b0fc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 cwde
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1c8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b1f0_1
		 cwde
OP_b1f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1f8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1f9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1fa:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1fb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b1fb_1
		 cwde
OP_b1fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1fc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 cmp   [R_A0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0c8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d0f0_1
		 cwde
OP_d0f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0f8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0f9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0fa:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0fb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d0fb_1
		 cwde
OP_d0fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0fc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 cwde
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1c8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d1f0_1
		 cwde
OP_d1f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1f8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1f9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1fa:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1fb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d1fb_1
		 cwde
OP_d1fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1fc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 add   [R_A0+ECX*4],EAX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b100:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 xor   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_D0+EBX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b11f:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b127:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b130_1
		 cwde
OP_b130_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b138:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b139:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b140:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 xor   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_D0+EBX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b170_1
		 cwde
OP_b170_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b178:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b179:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b180:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 xor   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_D0+EBX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_b1b0_1
		 cwde
OP_b1b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1b8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b1b9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c000:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c010:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c018:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c01f:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c020:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c027:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c028:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c030:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c030_1
		 cwde
OP_c030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c038:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c039:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c03a:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c03b:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c03b_1
		 cwde
OP_c03b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c03c:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 and   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c040:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c050:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c058:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c060:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c068:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c070:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c070_1
		 cwde
OP_c070_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c078:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c079:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c07a:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c07b:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c07b_1
		 cwde
OP_c07b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c07c:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 and   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c080:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c090:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c098:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c0b0_1
		 cwde
OP_c0b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0b8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0b9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0ba:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0bb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c0bb_1
		 cwde
OP_c0bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0bc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 and   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c11f:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c127:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c130_1
		 cwde
OP_c130_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c138:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c139:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 and   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c170_1
		 cwde
OP_c170_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c178:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c179:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 and   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c1b0_1
		 cwde
OP_c1b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1b8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1b9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 and   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d000:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d010:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d018:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d01f:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d020:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d027:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d028:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d030:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d030_1
		 cwde
OP_d030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d038:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d039:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d03a:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d03b:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d03b_1
		 cwde
OP_d03b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d03c:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 add   [R_D0+ECX*4],AL
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d040:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d048:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d050:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d058:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d060:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d068:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d070:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d070_1
		 cwde
OP_d070_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d078:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d079:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d07a:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d07b:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d07b_1
		 cwde
OP_d07b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d07c:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 add   [R_D0+ECX*4],AX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d080:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_D0+EBX*4]
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d088:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,[R_A0+EBX*4]
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d090:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d098:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d0b0_1
		 cwde
OP_d0b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0b8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0b9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0ba:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0bb:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d0bb_1
		 cwde
OP_d0bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d0bc:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EAX,dword [esi+ebp]
		 rol   EAX,16
		 add   esi,byte 4
		 add   [R_D0+ECX*4],EAX
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d11f:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 add   dword [R_A7],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d127:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   edi,[R_A7]    ; Get A7
		 sub   edi,byte 2
		 mov   [R_A7],edi
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d130_1
		 cwde
OP_d130_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d138:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d139:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 add   AL,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d170_1
		 cwde
OP_d170_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d178:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d179:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 add   AX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_d1b0_1
		 cwde
OP_d1b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1b8:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d1b9:
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 add   EAX,[R_D0+ECX*4]
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9100:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EBX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 sbb   [R_D0+ecx*4],BL
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_9100_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_9100_1:
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9108:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 bt    dword [R_XC],0
		 sbb   AL,BL
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_9108_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_9108_1:
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9140:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EBX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 sbb   [R_D0+ecx*4],BX
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_9140_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_9140_1:
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9148:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 bt    dword [R_XC],0
		 sbb   AX,BX
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_9148_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_9148_1:
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9180:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EBX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 sbb   [R_D0+ecx*4],EBX
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_9180_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_9180_1:
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_9188:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 bt    dword [R_XC],0
		 sbb   EAX,EBX
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_9188_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_9188_1:
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d100:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EBX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 adc   [R_D0+ecx*4],BL
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_d100_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_d100_1:
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d108:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 dec   EDI
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 bt    dword [R_XC],0
		 adc   AL,BL
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_d108_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_d108_1:
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d140:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EBX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 adc   [R_D0+ecx*4],BX
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_d140_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_d140_1:
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d148:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 bt    dword [R_XC],0
		 adc   AX,BX
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_d148_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_d148_1:
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d180:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EBX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 adc   [R_D0+ecx*4],EBX
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_d180_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_d180_1:
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_d188:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 bt    dword [R_XC],0
		 adc   EAX,EBX
		 mov   ebx,edx
		 pushfd
		 pop   EDX
		 mov   [R_XC],dl
		 jnz   short OP_d188_1

		 and   dl,0BFh       ; Remove Z
		 and   bl,40h        ; Mask out Old Z
		 or    dl,bl         ; Copy across

OP_d188_1:
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 30
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80c0:
		 sub   dword [_MC68000_ICount],133
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EBX,[R_D0+EBX*4]
		 or    bx,bx
		 je    near OP_80c0_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80c0_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080c0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080c0_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80d0:
		 sub   dword [_MC68000_ICount],137
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 or    bx,bx
		 je    near OP_80d0_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80d0_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080d0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080d0_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80d8:
		 sub   dword [_MC68000_ICount],137
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 or    bx,bx
		 je    near OP_80d8_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80d8_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080d8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080d8_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80e0:
		 sub   dword [_MC68000_ICount],139
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 or    bx,bx
		 je    near OP_80e0_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80e0_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080e0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080e0_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80e8:
		 sub   dword [_MC68000_ICount],141
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 or    bx,bx
		 je    near OP_80e8_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80e8_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080e8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080e8_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80f0:
		 sub   dword [_MC68000_ICount],145
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_80f0_2
		 cwde
OP_80f0_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 or    bx,bx
		 je    near OP_80f0_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80f0_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080f0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080f0_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80f8:
		 sub   dword [_MC68000_ICount],141
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 or    bx,bx
		 je    near OP_80f8_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80f8_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080f8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080f8_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80f9:
		 sub   dword [_MC68000_ICount],145
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 or    bx,bx
		 je    near OP_80f9_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80f9_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080f9_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080f9_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80fa:
		 sub   dword [_MC68000_ICount],141
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 or    bx,bx
		 je    near OP_80fa_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80fa_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080fa_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080fa_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80fb:
		 sub   dword [_MC68000_ICount],143
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_80fb_2
		 cwde
OP_80fb_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 or    bx,bx
		 je    near OP_80fb_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80fb_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080fb_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080fb_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80fc:
		 sub   dword [_MC68000_ICount],137
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 or    bx,bx
		 je    near OP_80fc_1		;do div by zero trap
		 mov   EAX,[R_D0+ECX*4]
		 movzx ebx,bx
		 xor   edx,edx
		 div   ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_80fc_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 95
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_080fc_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_080fc_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81c0:
		 sub   dword [_MC68000_ICount],150
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EAX,[R_D0+EBX*4]
		 or    ax,ax
		 je    near OP_81c0_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81c0_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081c0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081c0_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81d0:
		 sub   dword [_MC68000_ICount],154
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 or    ax,ax
		 je    near OP_81d0_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81d0_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081d0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081d0_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81d8:
		 sub   dword [_MC68000_ICount],154
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 or    ax,ax
		 je    near OP_81d8_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81d8_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081d8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081d8_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81e0:
		 sub   dword [_MC68000_ICount],156
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 or    ax,ax
		 je    near OP_81e0_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81e0_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081e0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081e0_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81e8:
		 sub   dword [_MC68000_ICount],158
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 or    ax,ax
		 je    near OP_81e8_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81e8_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081e8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081e8_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81f0:
		 sub   dword [_MC68000_ICount],162
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_81f0_2
		 cwde
OP_81f0_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 or    ax,ax
		 je    near OP_81f0_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81f0_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081f0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081f0_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81f8:
		 sub   dword [_MC68000_ICount],158
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 or    ax,ax
		 je    near OP_81f8_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81f8_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081f8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081f8_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81f9:
		 sub   dword [_MC68000_ICount],162
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 or    ax,ax
		 je    near OP_81f9_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81f9_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081f9_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081f9_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81fa:
		 sub   dword [_MC68000_ICount],158
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 or    ax,ax
		 je    near OP_81fa_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81fa_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081fa_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081fa_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81fb:
		 sub   dword [_MC68000_ICount],160
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_81fb_2
		 cwde
OP_81fb_2:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 mov   ebx,ecx
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 or    ax,ax
		 je    near OP_81fb_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81fb_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081fb_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081fb_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81fc:
		 sub   dword [_MC68000_ICount],154
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 or    ax,ax
		 je    near OP_81fc_1		;do div by zero trap
		 cwde
		 mov   ebx,eax
		 mov   EAX,[R_D0+ECX*4]
		 cdq
		 idiv  ebx
		 xor   ebx,ebx
		 test  eax, 0FFFF0000H
		 setnz bl
		 shl   ebx,10
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  DX,DX
		 pushfd
		 pop   EDX
		 or    edx,ebx		;V flag
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_81fc_1:		 ;Do divide by zero trap
		 add   dword [_MC68000_ICount],byte 112
		 sub   esi,byte 2
		 mov   al,5
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_081fc_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_081fc_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4840:
		 and   ecx, byte 7
		 ror   dword [R_D0+ECX*4],16
		 or    dword [R_D0+ECX*4],0
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4000:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 neg   AL
		 bt    dword [R_XC],0
		 sbb   AL,0
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4010:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 bt    dword [R_XC],0
		 sbb   AL,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4018:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 bt    dword [R_XC],0
		 sbb   AL,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4020:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 bt    dword [R_XC],0
		 sbb   AL,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4028:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 bt    dword [R_XC],0
		 sbb   AL,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4030:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4030_1
		 cwde
OP_4030_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 bt    dword [R_XC],0
		 sbb   AL,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4038:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 bt    dword [R_XC],0
		 sbb   AL,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4039:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 bt    dword [R_XC],0
		 sbb   AL,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4040:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 neg   AX
		 bt    dword [R_XC],0
		 sbb   AX,0
		 pushfd
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4050:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 bt    dword [R_XC],0
		 sbb   AX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4058:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 bt    dword [R_XC],0
		 sbb   AX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4060:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 bt    dword [R_XC],0
		 sbb   AX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4068:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 bt    dword [R_XC],0
		 sbb   AX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4070:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4070_1
		 cwde
OP_4070_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 bt    dword [R_XC],0
		 sbb   AX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4078:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 bt    dword [R_XC],0
		 sbb   AX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4079:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 bt    dword [R_XC],0
		 sbb   AX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4080:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 neg   EAX
		 bt    dword [R_XC],0
		 sbb   EAX,0
		 pushfd
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4090:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 bt    dword [R_XC],0
		 sbb   EAX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4098:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 bt    dword [R_XC],0
		 sbb   EAX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40a0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 bt    dword [R_XC],0
		 sbb   EAX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40a8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 bt    dword [R_XC],0
		 sbb   EAX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40b0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_40b0_1
		 cwde
OP_40b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 bt    dword [R_XC],0
		 sbb   EAX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 bt    dword [R_XC],0
		 sbb   EAX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_40b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 bt    dword [R_XC],0
		 sbb   EAX,0
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4200:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   [R_D0+ECX*4],AL
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4210:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4218:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4220:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4228:
		 and   ecx,byte 7
		 xor   eax,eax
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4230:
		 and   ecx,byte 7
		 xor   eax,eax
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4230_1
		 cwde
OP_4230_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4238:
		 xor   eax,eax
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4239:
		 xor   eax,eax
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4240:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   [R_D0+ECX*4],AX
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4250:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4258:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4260:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4268:
		 and   ecx,byte 7
		 xor   eax,eax
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4270:
		 and   ecx,byte 7
		 xor   eax,eax
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4270_1
		 cwde
OP_4270_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4278:
		 xor   eax,eax
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4279:
		 xor   eax,eax
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4280:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   [R_D0+ECX*4],EAX
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4290:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4298:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42a0:
		 and   ecx,byte 7
		 xor   eax,eax
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42a8:
		 and   ecx,byte 7
		 xor   eax,eax
		 push  EAX
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42b0:
		 and   ecx,byte 7
		 xor   eax,eax
		 push  EAX
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_42b0_1
		 cwde
OP_42b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42b8:
		 xor   eax,eax
		 push  EAX
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_42b9:
		 xor   eax,eax
		 push  EAX
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 pop   EAX
		 mov   [R_PC],ESI
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 mov   edx,40H
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4400:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 neg   AL
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4410:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4418:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4420:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4428:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4430:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4430_1
		 cwde
OP_4430_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4438:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4439:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 neg   AL
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4440:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 neg   AX
		 pushfd
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4450:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4458:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4460:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4468:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4470:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4470_1
		 cwde
OP_4470_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4478:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4479:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 neg   AX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4480:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 neg   EAX
		 pushfd
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4490:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4498:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44a0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44a8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44b0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_44b0_1
		 cwde
OP_44b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_44b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 neg   EAX
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4600:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 xor   AL,-1
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4610:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4618:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4620:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4628:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4630:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4630_1
		 cwde
OP_4630_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4638:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4639:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 pop   ECX
		 xor   AL,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4640:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 xor   AX,-1
		 pushfd
		 mov   [R_D0+ECX*4],AX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4650:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4658:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4660:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4668:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4670:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4670_1
		 cwde
OP_4670_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4678:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4679:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 xor   AX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4680:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 xor   EAX,-1
		 pushfd
		 mov   [R_D0+ECX*4],EAX
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4690:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4698:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46a0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46a8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46b0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_46b0_1
		 cwde
OP_46b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46b8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_46b9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   ECX
		 xor   EAX,-1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 28
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e60
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 jz    short OP_4e60_Trap
		 and   ecx,7
		 mov   eax,[R_A0+ECX*4]
		 mov   [R_USP],eax
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_4e60_Trap:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04e60_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04e60_Bank:
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e68
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 jz    short OP_4e68_Trap
		 and   ecx,7
		 mov   eax,[R_USP]
		 mov   [R_A0+ECX*4],eax
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_4e68_Trap:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04e68_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04e68_Bank:
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4180:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_4180_Trap_minus
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 cmp   bx,ax
		 jg    near OP_4180_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4180_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04180_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04180_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4180_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_14180_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_14180_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4190:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_4190_Trap_minus
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 cmp   bx,ax
		 jg    near OP_4190_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4190_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04190_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04190_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4190_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_14190_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_14190_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4198:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_4198_Trap_minus
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 cmp   bx,ax
		 jg    near OP_4198_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4198_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04198_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04198_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4198_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_14198_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_14198_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41a0:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_41a0_Trap_minus
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 cmp   bx,ax
		 jg    near OP_41a0_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41a0_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_041a0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_041a0_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41a0_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_141a0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_141a0_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41a8:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_41a8_Trap_minus
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 cmp   bx,ax
		 jg    near OP_41a8_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41a8_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_041a8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_041a8_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41a8_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_141a8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_141a8_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41b0:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_41b0_Trap_minus
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_41b0_1
		 cwde
OP_41b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 cmp   bx,ax
		 jg    near OP_41b0_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41b0_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_041b0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_041b0_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41b0_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_141b0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_141b0_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41b8:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_41b8_Trap_minus
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 cmp   bx,ax
		 jg    near OP_41b8_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41b8_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_041b8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_041b8_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41b8_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_141b8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_141b8_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41b9:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_41b9_Trap_minus
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 cmp   bx,ax
		 jg    near OP_41b9_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41b9_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_041b9_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_041b9_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41b9_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_141b9_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_141b9_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41ba:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_41ba_Trap_minus
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 cmp   bx,ax
		 jg    near OP_41ba_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41ba_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_041ba_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_041ba_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41ba_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_141ba_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_141ba_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41bb:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_41bb_Trap_minus
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_41bb_1
		 cwde
OP_41bb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 cmp   bx,ax
		 jg    near OP_41bb_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41bb_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_041bb_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_041bb_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41bb_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_141bb_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_141bb_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41bc:
		 mov   ebx,ecx
		 shr   ebx,byte 9
		 and   ebx,byte 7
		 mov   ebx,[R_D0+EBX*4]
		 test  ebx,8000h
		 jnz   near OP_41bc_Trap_minus
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 cmp   bx,ax
		 jg    near OP_41bc_Trap_over
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41bc_Trap_minus:
		 or    dl,80h
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_041bc_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_041bc_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_41bc_Trap_over:
		 and   dl,7Fh
		 sub   esi,byte 2
		 mov   al,6
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_141bc_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_141bc_Bank:
		 sub   dword [_MC68000_ICount],byte 44
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c140:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   eax,[R_D0+ECX*4]
		 mov   edi,[R_D0+EBX*4]
		 mov   [R_D0+ECX*4],edi
		 mov   [R_D0+EBX*4],eax
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c148:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   eax,[R_A0+ECX*4]
		 mov   edi,[R_A0+EBX*4]
		 mov   [R_A0+ECX*4],edi
		 mov   [R_A0+EBX*4],eax
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c188:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   eax,[R_D0+ECX*4]
		 mov   edi,[R_A0+EBX*4]
		 mov   [R_D0+ECX*4],edi
		 mov   [R_A0+EBX*4],eax
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b108:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 inc   dword [R_A0+EBX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 cmp   AL,BL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b148:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 cmp   AX,BX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_b188:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 cmp   EAX,EBX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EAX,[R_D0+EBX*4]
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 54
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 58
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 58
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 60
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 62
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c0f0_1
		 cwde
OP_c0f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 64
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0f8:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 62
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0f9:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 66
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0fa:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 62
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0fb:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c0fb_1
		 cwde
OP_c0fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 64
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c0fc:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mul   word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 58
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1c0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EAX,[R_D0+EBX*4]
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 54
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1d0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 58
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1d8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 add   dword [R_A0+EBX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 58
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1e0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+EBX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 60
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1e8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+EBX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 62
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1f0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,[R_A0+EBX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c1f0_1
		 cwde
OP_c1f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 64
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1f8:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 62
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1f9:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 66
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1fa:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 62
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1fb:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_c1fb_1
		 cwde
OP_c1fb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  ECX
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   ECX
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 64
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_c1fc:
		 shr   ecx, byte 9
		 and   ecx, byte 7
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 imul  word [R_D0+ECX*4]
		 shl   edx, byte 16
		 mov   dx,ax
		 mov   [R_D0+ECX*4],edx
		 test  EDX,EDX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 58
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e77:
		 mov   edi,[R_A7]
		 add   dword [R_A7],byte 6
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 add   edi,byte 2
		 mov   esi,eax
		 mov   [R_PC],ESI
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 xchg  esi,eax
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04e77_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04e77_Bank:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e75:
		 sub   esi,byte 2
		 mov   [_previouspc],esi
		 mov   eax,[R_A7]
		 add   dword [R_A7],byte 4
		 mov   [R_PC],ESI
		 push  EDX
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_readmem24_dword
		 pop   EDX
		 pop   EDX
		 mov   esi,eax
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04e75_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04e75_Bank:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e90:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   eax,esi		; Old PC
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   esi,edi		; New PC
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   ECX,0FFFFFFh
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04e90_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04e90_Bank:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ea8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   eax,esi		; Old PC
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   esi,edi		; New PC
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   ECX,0FFFFFFh
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04ea8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04ea8_Bank:
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4eb0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4eb0_1
		 cwde
OP_4eb0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   eax,esi		; Old PC
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   esi,edi		; New PC
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   ECX,0FFFFFFh
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04eb0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04eb0_Bank:
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4eb8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   eax,esi		; Old PC
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   esi,edi		; New PC
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   ECX,0FFFFFFh
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04eb8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04eb8_Bank:
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4eb9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   eax,esi		; Old PC
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   esi,edi		; New PC
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   ECX,0FFFFFFh
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04eb9_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04eb9_Bank:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4eba:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   eax,esi		; Old PC
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   esi,edi		; New PC
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   ECX,0FFFFFFh
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04eba_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04eba_Bank:
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ebb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4ebb_1
		 cwde
OP_4ebb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   eax,esi		; Old PC
		 mov   ecx,[R_A7]	 ; Push onto Stack
		 sub   ecx,byte 4
		 mov   esi,edi		; New PC
		 mov   [R_A7],ecx
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   ECX,0FFFFFFh
		 push  ECX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04ebb_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04ebb_Bank:
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ed0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   esi,edi
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04ed0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04ed0_Bank:
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ee8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   esi,edi
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04ee8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04ee8_Bank:
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ef0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4ef0_1
		 cwde
OP_4ef0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   esi,edi
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04ef0_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04ef0_Bank:
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ef8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   esi,edi
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04ef8_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04ef8_Bank:
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ef9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   esi,edi
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04ef9_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04ef9_Bank:
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4efa:
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   esi,edi
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04efa_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04efa_Bank:
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4efb:
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4efb_1
		 cwde
OP_4efb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   esi,edi
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04efb_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04efb_Bank:
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4800:
		 and   ecx, byte 7
		 mov   EBX,[R_D0+ECX*4]
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4810:
		 and   ecx, byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4818:
		 and   ecx, byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4820:
		 and   ecx, byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4828:
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4830:
		 and   ecx, byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4830_1
		 cwde
OP_4830_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4838:
		 and   ecx, byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4839:
		 and   ecx, byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_483a:
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_483b:
		 and   ecx, byte 7
		 mov   edi,esi           ; Get PC
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_483b_1
		 cwde
OP_483b_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 mov   EBX,EAX
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_483c:
		 and   ecx, byte 7
		 mov   EBX,dword [esi+ebp]
		 add   esi,byte 2
		 xor   eax,eax
		 bt    dword [R_XC],0
		 sbb   al,bl
		 das
		 pushfd
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ac0:
		 and   ecx, byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  AL,AL
		 pushfd
		 or    al,128
		 mov   [R_D0+ECX*4],AL
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ad0:
		 and   ecx, byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 or    al,128
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ad8:
		 and   ecx, byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 or    al,128
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ae0:
		 and   ecx, byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 or    al,128
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ae8:
		 and   ecx, byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 or    al,128
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4af0:
		 and   ecx, byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4af0_1
		 cwde
OP_4af0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 or    al,128
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4af8:
		 and   ecx, byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 or    al,128
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4af9:
		 and   ecx, byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 pop   ECX
		 mov   ecx,ebx
		 test  AL,AL
		 pushfd
		 or    al,128
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 26
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e40:
		 and   ecx,byte 15
		 mov   eax,32
		 add   eax,ecx
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04e40_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04e40_Bank:
		 sub   dword [_MC68000_ICount],byte 34
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e76
		 test  edx,0800h
		 jz    near OP_4e76_Clear
		 sub   esi,byte 2
		 mov   al,7
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04e76_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04e76_Bank:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_4e76_Clear:
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e70:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 jnz   near OP_4e70_NOP
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04e70_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04e70_Bank:
		 sub   dword [_MC68000_ICount],132
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_4e70_NOP:
		 sub   dword [_MC68000_ICount],132
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e71:
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e72:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 jne   near OP_4e72_1

		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04e72_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04e72_Bank:
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_4e72_1:
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 test  ah,20h 			; User Mode ?
		 jne   short OP_4e72_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_4e72_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 or    byte [R_IRQ],80h
		 xor   eax,eax
		 mov   [_MC68000_ICount],eax
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4880:
		 and   ecx, byte 7
		 movsx eax,byte [R_D0+ECX*4]
		 mov   [R_D0+ECX*4],ax
		 test  AX,AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48c0:
		 and   ecx, byte 7
		 movsx eax,word [R_D0+ECX*4]
		 mov   [R_D0+ECX*4],eax
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e73:
		 test  byte [R_SR_H],20h 			; Supervisor Mode ?
		 je    near OP_4e73_1

		 mov   edi,[R_A7]
		 add   dword [R_A7],byte 6
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 add   edi,byte 2
		 mov   esi,eax
		 mov   [R_PC],ESI
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 xchg  esi,eax
		 test  ah,20h 			; User Mode ?
		 jne   short OP_4e73_2

		 mov   edx,[R_A7]
		 mov   [R_ISP],edx
		 mov   edx,[R_USP]
		 mov   [R_A7],edx
OP_4e73_2:
		 mov   byte [R_SR_H],ah 	;T, S & I
		 and   eax,byte 1Fh
		 mov   edx,[IntelFlag+eax*4]
		 mov   [R_XC],dh
		 and   edx,0EFFh
		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_04e73_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_04e73_Bank:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
OP_4e73_1:
		 sub   esi,byte 2
		 mov   al,8
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_14e73_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_14e73_Bank:
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a00:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  AL,AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a10:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a18:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 inc   dword [R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a20:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 dec   EDI
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a28:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a30:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4a30_1
		 cwde
OP_4a30_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a38:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a39:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24
		 add   esp,byte 4
		 test  AL,AL
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a40:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  AX,AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a50:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a58:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a60:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 10
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a68:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a70:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4a70_1
		 cwde
OP_4a70_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a78:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a79:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 add   esp,byte 4
		 test  AX,AX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a80:
		 and   ecx,byte 7
		 mov   EAX,[R_D0+ECX*4]
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 4
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a90:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4a98:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4aa0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 4
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4aa8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ab0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4ab0_1
		 cwde
OP_4ab0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ab8:
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ab9:
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_dword
		 add   esp,byte 4
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4890:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   ebx,1
		 mov   ecx,4h
OP_4890_Again:
		 test  edx,ebx
		 je    OP_4890_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_4890_Skip:
		 add   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4890_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48a0:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 push  ecx
		 mov   edi,[R_A0+ECX*4]
		 mov   ebx,1
		 mov   ecx,40h
OP_48a0_Again:
		 test  edx,ebx
		 je    OP_48a0_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 sub   edi,byte 2
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 sub   dword [_MC68000_ICount],byte 4
OP_48a0_Skip:
		 sub   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48a0_Again
		 pop   ecx
		 mov   [R_A0+ECX*4],edi
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48a8:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   ebx,1
		 mov   ecx,4h
OP_48a8_Again:
		 test  edx,ebx
		 je    OP_48a8_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_48a8_Skip:
		 add   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48a8_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48b0:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_48b0_1
		 cwde
OP_48b0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   ebx,1
		 mov   ecx,4h
OP_48b0_Again:
		 test  edx,ebx
		 je    OP_48b0_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_48b0_Skip:
		 add   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48b0_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48b8:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   ebx,1
		 mov   ecx,4h
OP_48b8_Again:
		 test  edx,ebx
		 je    OP_48b8_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_48b8_Skip:
		 add   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48b8_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48b9:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   ebx,1
		 mov   ecx,4h
OP_48b9_Again:
		 test  edx,ebx
		 je    OP_48b9_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_48b9_Skip:
		 add   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48b9_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48d0:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   ebx,1
		 mov   ecx,4h
OP_48d0_Again:
		 test  edx,ebx
		 je    OP_48d0_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_48d0_Skip:
		 add   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48d0_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48e0:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 push  ecx
		 mov   edi,[R_A0+ECX*4]
		 mov   ebx,1
		 mov   ecx,40h
OP_48e0_Again:
		 test  edx,ebx
		 je    OP_48e0_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 sub   edi,byte 4
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 sub   dword [_MC68000_ICount],byte 8
OP_48e0_Skip:
		 sub   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48e0_Again
		 pop   ecx
		 mov   [R_A0+ECX*4],edi
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48e8:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   ebx,1
		 mov   ecx,4h
OP_48e8_Again:
		 test  edx,ebx
		 je    OP_48e8_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_48e8_Skip:
		 add   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48e8_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48f0:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_48f0_1
		 cwde
OP_48f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   ebx,1
		 mov   ecx,4h
OP_48f0_Again:
		 test  edx,ebx
		 je    OP_48f0_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_48f0_Skip:
		 add   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48f0_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48f8:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   ebx,1
		 mov   ecx,4h
OP_48f8_Again:
		 test  edx,ebx
		 je    OP_48f8_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_48f8_Skip:
		 add   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48f8_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_48f9:
		 push edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   ebx,1
		 mov   ecx,4h
OP_48f9_Again:
		 test  edx,ebx
		 je    OP_48f9_Skip
		 mov   eax,[_MC68000_ICount+ecx]
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 push  EAX
		 mov   EAX,EDI
		 and   EAX,0FFFFFFh
		 push  EAX
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 pop   ECX
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_48f9_Skip:
		 add   ecx,4h
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_48f9_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4c90:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   ebx,1
		 mov   ecx,4h
OP_4c90_Again:
		 test  edx,ebx
		 je    OP_4c90_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_4c90_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4c90_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4c98:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 push   ecx
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   ebx,1
		 mov   ecx,4h
OP_4c98_Again:
		 test  edx,ebx
		 je    OP_4c98_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_4c98_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4c98_Again
		 pop   ecx
		 mov   [R_A0+ECX*4],edi
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ca8:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   ebx,1
		 mov   ecx,4h
OP_4ca8_Again:
		 test  edx,ebx
		 je    OP_4ca8_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_4ca8_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4ca8_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cb0:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4cb0_1
		 cwde
OP_4cb0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   ebx,1
		 mov   ecx,4h
OP_4cb0_Again:
		 test  edx,ebx
		 je    OP_4cb0_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_4cb0_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cb0_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cb8:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   ebx,1
		 mov   ecx,4h
OP_4cb8_Again:
		 test  edx,ebx
		 je    OP_4cb8_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_4cb8_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cb8_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cb9:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   ebx,1
		 mov   ecx,4h
OP_4cb9_Again:
		 test  edx,ebx
		 je    OP_4cb9_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_4cb9_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cb9_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cba:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   ebx,1
		 mov   ecx,4h
OP_4cba_Again:
		 test  edx,ebx
		 je    OP_4cba_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_4cba_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cba_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cbb:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4cbb_1
		 cwde
OP_4cbb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   ebx,1
		 mov   ecx,4h
OP_4cbb_Again:
		 test  edx,ebx
		 je    OP_4cbb_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_word
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 cwde
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 2
		 sub   dword [_MC68000_ICount],byte 4
OP_4cbb_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cbb_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cd0:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   ebx,1
		 mov   ecx,4h
OP_4cd0_Again:
		 test  edx,ebx
		 je    OP_4cd0_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_4cd0_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cd0_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cd8:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 push   ecx
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 4
		 mov   ebx,1
		 mov   ecx,4h
OP_4cd8_Again:
		 test  edx,ebx
		 je    OP_4cd8_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_4cd8_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cd8_Again
		 pop   ecx
		 mov   [R_A0+ECX*4],edi
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4ce8:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   ebx,1
		 mov   ecx,4h
OP_4ce8_Again:
		 test  edx,ebx
		 je    OP_4ce8_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_4ce8_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4ce8_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cf0:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4cf0_1
		 cwde
OP_4cf0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   ebx,1
		 mov   ecx,4h
OP_4cf0_Again:
		 test  edx,ebx
		 je    OP_4cf0_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_4cf0_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cf0_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cf8:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   ebx,1
		 mov   ecx,4h
OP_4cf8_Again:
		 test  edx,ebx
		 je    OP_4cf8_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_4cf8_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cf8_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cf9:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   ebx,1
		 mov   ecx,4h
OP_4cf9_Again:
		 test  edx,ebx
		 je    OP_4cf9_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_4cf9_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cf9_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cfa:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 movsx EAX,word [esi+ebp]
		 mov   EDI,ESI           ; Get PC
		 add   esi,byte 2
		 add   edi,eax         ; Add Offset to PC
		 mov   ebx,1
		 mov   ecx,4h
OP_4cfa_Again:
		 test  edx,ebx
		 je    OP_4cfa_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_4cfa_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cfa_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4cfb:
		 push  edx
		 mov   EDX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edi,esi           ; Get PC
		 push  edx
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_4cfb_1
		 cwde
OP_4cfb_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 pop   edx
		 mov   ebx,1
		 mov   ecx,4h
OP_4cfb_Again:
		 test  edx,ebx
		 je    OP_4cfb_Skip
		 mov   [R_PC],ESI
		 push  ECX
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_dword
		 pop   ECX
		 pop   EDX
		 pop   ECX
		 mov   [_MC68000_ICount+ecx],eax
		 add   edi,byte 4
		 sub   dword [_MC68000_ICount],byte 8
OP_4cfb_Skip:
		 add   ecx,byte 4
		 shl   ebx,1
		 or    bx,bx
		 jnz   OP_4cfb_Again
		 pop   edx
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e50:
		 sub   dword [R_A7],byte 4
		 and   ecx, byte 7
		 mov   eax,[R_A0+ECX*4]
		 mov   edi,[R_A7]
		 mov   [R_A0+ECX*4],edi
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_writemem24_dword
		 add   esp,byte 8
		 pop   EDX
		 movsx EAX,word [esi+ebp]
		 add   esi,byte 2
		 add   [R_A7],eax
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_4e58:
		 mov   ebx,ecx
		 and   ebx, byte 7
		 mov   edi,[R_A0+EBX*4]
		 mov   [R_PC],ESI
		 push  EDX
		 mov   eax,EDI
		 and   eax,0FFFFFFh
		 push  eax
		 call  _cpu_readmem24_dword
		 pop   EDX
		 pop   EDX
		 mov   [R_A0+EBX*4],eax
		 add   edi,byte 4
		 mov   dword [R_A7],EDI
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e000:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 sar   AL,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e000_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e000_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e020:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 sar   AL,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e020_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e020_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e040:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 sar   AX,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e040_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e040_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e060:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 sar   AX,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e060_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e060_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e080:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 sar   EAX,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e080_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e080_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 sar   EAX,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e0a0_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0a0_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e100:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 sal   AL,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e100_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e100_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e120:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 sal   AL,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e120_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e120_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e140:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 sal   AX,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e140_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e140_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e160:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 sal   AX,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e160_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e160_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e180:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 sal   EAX,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e180_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e180_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1a0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 sal   EAX,cl
		 pushfd
		 pop   EDX
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e1a0_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1a0_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sar   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sar   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sar   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sar   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_e0f0_1
		 cwde
OP_e0f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sar   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0f8:
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sar   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0f9:
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sar   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sal   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sal   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sal   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sal   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_e1f0_1
		 cwde
OP_e1f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sal   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1f8:
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sal   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1f9:
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 sal   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e010:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcr   AL,cl
		 setc  ch
		 test  AL,AL
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e010_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e010_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e030:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcr   AL,cl
		 setc  ch
		 test  AL,AL
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e030_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e030_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e050:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcr   AX,cl
		 setc  ch
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e050_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e050_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e070:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcr   AX,cl
		 setc  ch
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e070_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e070_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e090:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcr   EAX,cl
		 setc  ch
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e090_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e090_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcr   EAX,cl
		 setc  ch
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e0b0_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0b0_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e110:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcl   AL,cl
		 setc  ch
		 test  AL,AL
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e110_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e110_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e130:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcl   AL,cl
		 setc  ch
		 test  AL,AL
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e130_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e130_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e150:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcl   AX,cl
		 setc  ch
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e150_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e150_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e170:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcl   AX,cl
		 setc  ch
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e170_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e170_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e190:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcl   EAX,cl
		 setc  ch
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e190_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e190_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1b0:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 bt    dword [R_XC],0
		 rcl   EAX,cl
		 setc  ch
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e1b0_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1b0_1:
		 and   dl,254		;clear C flag
		 mov   cl,byte [R_XC]
		 and   cl,1
		 or    dl,cl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e4d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcr   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e4d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcr   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e4e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcr   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e4e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcr   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e4f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_e4f0_1
		 cwde
OP_e4f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcr   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e4f8:
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcr   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e4f9:
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcr   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e5d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcl   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e5d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcl   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e5e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcl   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e5e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcl   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e5f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_e5f0_1
		 cwde
OP_e5f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcl   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e5f8:
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcl   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e5f9:
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 bt    dword [R_XC],0
		 rcl   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e008:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 shr   AL,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e008_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e008_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e028:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 shr   AL,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e028_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e028_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e048:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 shr   AX,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e048_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e048_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e068:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 shr   AX,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e068_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e068_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e088:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 shr   EAX,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e088_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e088_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 shr   EAX,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e0a8_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0a8_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e108:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 shl   AL,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e108_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e108_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e128:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 shl   AL,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e128_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e128_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e148:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 shl   AX,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e148_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e148_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e168:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 shl   AX,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e168_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e168_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e188:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 shl   EAX,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e188_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e188_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1a8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 shl   EAX,cl
		 pushfd
		 pop   EDX
		 xor   dh,dh
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e1a8_1
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1a8_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e2d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shr   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e2d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shr   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e2e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shr   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e2e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shr   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e2f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_e2f0_1
		 cwde
OP_e2f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shr   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e2f8:
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shr   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e2f9:
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shr   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e3d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shl   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e3d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shl   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e3e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shl   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e3e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shl   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e3f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_e3f0_1
		 cwde
OP_e3f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shl   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e3f8:
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shl   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e3f9:
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 shl   ax,1
		 pushfd
		 mov   [R_PC],ESI
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 mov   [R_XC],dl
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e018:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 ror   AL,cl
		 setc  ch
		 test  AL,AL
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e018_1
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e018_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e038:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 ror   AL,cl
		 setc  ch
		 test  AL,AL
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e038_1
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e038_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e058:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 ror   AX,cl
		 setc  ch
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e058_1
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e058_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e078:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 ror   AX,cl
		 setc  ch
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e078_1
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e078_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e098:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 ror   EAX,cl
		 setc  ch
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e098_1
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e098_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0b8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 ror   EAX,cl
		 setc  ch
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e0b8_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e0b8_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e118:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 rol   AL,cl
		 setc  ch
		 test  AL,AL
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e118_1
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e118_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e138:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 rol   AL,cl
		 setc  ch
		 test  AL,AL
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AL
		 or    cl,cl
		 jz    OP_e138_1
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e138_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e158:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 rol   AX,cl
		 setc  ch
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e158_1
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e158_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 22
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e178:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 rol   AX,cl
		 setc  ch
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],AX
		 or    cl,cl
		 jz    OP_e178_1
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e178_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 6
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e198:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 dec   ecx          ; Move range down
		 and   ecx,byte 7   ; Mask out lower bits
		 inc   ecx          ; correct range
		 mov   EAX,[R_D0+EBX*4]
		 rol   EAX,cl
		 setc  ch
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e198_1
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e198_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 24
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1b8:
		 mov   ebx,ecx
		 and   ebx,byte 7
		 shr   ecx,byte 9
		 and   ecx,byte 7
		 mov   ECX,[R_D0+ECX*4]
		 and   ecx,byte 63
		 mov   EAX,[R_D0+EBX*4]
		 rol   EAX,cl
		 setc  ch
		 test  EAX,EAX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,ch
		 mov   [R_D0+EBX*4],EAX
		 or    cl,cl
		 jz    OP_e1b8_1
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e1b8_1:
		 and   dl,254		;clear C flag
		 sub   dword [_MC68000_ICount],byte 8
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e6d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 ror   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e6d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 ror   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e6e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 ror   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e6e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 ror   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e6f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_e6f0_1
		 cwde
OP_e6f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 ror   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e6f8:
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 ror   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e6f9:
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 ror   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e7d0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 rol   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e7d8:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 add   dword [R_A0+ECX*4],byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 rol   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 12
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e7e0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 sub   EDI,byte 2
		 mov   [R_A0+ECX*4],EDI
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 rol   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 14
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e7e8:
		 and   ecx,byte 7
		 movsx EAX,word [esi+ebp]
		 mov   EDI,[R_A0+ECX*4]
		 add   esi,byte 2
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 rol   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e7f0:
		 and   ecx,byte 7
		 mov   EDI,[R_A0+ECX*4]
		 mov   EAX,dword [esi+ebp]
		 add   esi,byte 2
		 mov   edx,eax
		 shr   eax,10
		 and   eax,byte 3Ch
		 mov   eax,[R_D0+eax]
		 test  dx,800H
		 jnz   short OP_e7f0_1
		 cwde
OP_e7f0_1:
		 add   edi,eax
		 movsx eax,dl
		 add   edi,eax
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 rol   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 18
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e7f8:
		 and   ecx,byte 7
		 movsx EDI,word [esi+ebp]
		 add   esi,byte 2
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 rol   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 16
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_e7f9:
		 and   ecx,byte 7
		 mov   EDI,dword [esi+ebp]
		 rol   EDI,16
		 add   esi,byte 4
		 mov   [R_PC],ESI
		 mov   ebx,ecx
		 and   EDI,0FFFFFFh
		 push  EDI
		 call  _cpu_readmem24_word
		 pop   ECX
		 mov   ecx,ebx
		 rol   ax,1
		 setc  bl
		 test  AX,AX
		 pushfd
		 pop   EDX
		 and   dl,254
		 or    dl,bl
		 mov   [R_PC],ESI
		 push  EDX
		 push  EAX
		 push  EDI
		 call  _cpu_writemem24_word
		 add   esp,byte 8
		 pop   EDX
		 sub   dword [_MC68000_ICount],byte 20
		 js    near MainExit

; Check for Interrupt waiting

		 test  byte [R_IRQ],07fH
		 jne   near interrupt

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_a000:
		 sub   esi,byte 2
		 mov   al,10
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_0a000_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_0a000_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

OP_fabe:
		 call	_neogeo_exit
		 jmp	OP_0f000_Bank
		 ALIGN 4

OP_fabf:
	 mov	dword [_img_display], 1
		 call	_cdrom_load_files
		 jmp	OP_0f000_Bank
		 ALIGN 4

OP_fac0:
	 mov	dword [_img_display], 0
		 call	_cdrom_load_files
		 jmp	OP_0f000_Bank
		 ALIGN 4

OP_fac1:
		 call	_neogeo_upload
		 jmp	OP_0f000_Bank
		 ALIGN 4

OP_fac2:
		 call	_neogeo_prio_switch
		 jmp	OP_0f000_Bank
		 ALIGN 4

OP_f000:
		 sub   esi,byte 2
		 mov   al,11
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_0f000_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_0f000_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		 ALIGN 4

ILLEGAL:
		 call _neogeo_exception	; FROM NEOCD.C
		 sub   esi,byte 2
		 mov   al,4
		 call  Exception

		 and   esi,0ffffffh
		 mov   eax,esi
		 and   eax,0ffff0000h
		 cmp   [asmbank],eax
		 je    OP_0fffe_Bank
		 mov   [asmbank],eax
		 mov   [R_CCR],edx
		 push  esi
		 call  _cpu_setOPbase24
		 add   esp,byte 4
		 mov   edx,[R_CCR]
		 mov   ebp,dword [_OP_ROM]
OP_0fffe_Bank:
		 or    dword [_MC68000_ICount],0
		 js    near MainExit

		 xor   ecx,ecx		; Avoid Stall (P2)
		 mov   cx,[esi+ebp]

		 add   esi,byte 2

		 jmp   [OPCODETABLE+ecx*4]
		SECTION .data


		 align 16


; Register Structure

_MC68000_ICount	 DD 0

_regs
R_D0	 DD 0			 ; Data Registers
R_D1	 DD 0
R_D2	 DD 0
R_D3	 DD 0
R_D4	 DD 0
R_D5	 DD 0
R_D6	 DD 0
R_D7	 DD 0

R_A0	 DD 0			 ; Address Registers
R_A1	 DD 0
R_A2	 DD 0
R_A3	 DD 0
R_A4	 DD 0
R_A5	 DD 0
R_A6	 DD 0
R_A7	 DD 0

R_USP	 DD 0			 ; Stack Registers
R_ISP	 DD 0

R_SR_H	 DD 0			 ; Status Register High TuSuuIII
R_CCR	 DD 0			 ; CCR Register in Intel Format
R_XC	 DD 0			 ; Extended Carry uuuuuuuX
R_PC	 DD 0			 ; Program Counter
R_IRQ	 DD 0			 ; IRQ Request Level

R_SR	 DD 0			 ; Motorola Format SR

		 DD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		 DD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		 DD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		 DD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		 DD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		 DD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		 DD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		 DD 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

asmbank	 DD 0

Safe_EBX	 DD 0
Safe_ECX	 DD 0
Safe_EDI	 DD 0

		 ALIGN 16


IntelFlag				; Intel Flag Lookup Table
		 DD 0000h,0001h,0800h,0801h,0040h,0041h,0840h,0841h
		 DD 0080h,0081h,0880h,0881h,00C0h,00C1h,08C0h,08C1h
		 DD 0100h,0101h,0900h,0901h,0140h,0141h,0940h,0941h
		 DD 0180h,0181h,0980h,0981h,01C0h,01C1h,09C0h,09C1h
exception_cycles
		 DB 0, 0, 0, 0, 38, 42, 44, 38, 38, 0, 38, 38, 0, 0, 0, 0
		 DB 0, 0, 0, 0, 0, 0, 0, 0, 46, 46, 46, 46, 46, 46, 46, 46
		 DB 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38, 38

; RLE Compressed Jump Table

COMPTABLE

%include 'src\mc68000\comptab.asm'

		DD   0,0

		SECTION .bss

OPCODETABLE	RESD  65536

